<?php
/**
 *    This file is part of OXIDJson.
 *
 *    OXIDJson is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    OXIDJson is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this package.  If not, see <http://www.gnu.org/licenses/>.
 */

use Tonic\Response;

/**
 * @uri /oxobject/:class/:oxid
 */
class OxRestObject extends OxRestBase
{
    /**
     * @method GET
     * @json
     * @param string $class
     * @param string $oxid
     * @return Tonic\Response
     */
    public function returnOxObject($class = null, $oxid = null)
    {

        $class = $this->erx_get_class_alias($class);
        $this->erx_check_is_class_allowed($class);

        try {
            /** @var oxBase $o */
            $o = oxNew($class);
            $o->disableLazyLoading();
            if ($o->load($oxid)) {
                return new Response(200, $this->_oxObject2Array($o));
            }
        } catch (Exception $ex) {

        }

        return new Response(404, "Not found");
    }

}
